// Define a name for the test module.
#define BOOST_TEST_MODULE testRead
// Only after defining the name include the unit test header.
#include <boost/test/included/unit_test.hpp>

#include <ChimeraTK/ApplicationCore/TestFacility.h>
#include "Server.h"
#include "TecDummy.h"


using namespace boost::unit_test_framework;
using namespace ChimeraTK;

BOOST_AUTO_TEST_SUITE(tecTestSuite)

constexpr char TECDummyCDD[] = "(TecDummy:?map=dummydevice.map)";

BOOST_AUTO_TEST_CASE(testReadOnlyInteger){
  std::cout << "testReadOnDemandInteger" << std::endl;
  
  Server tec_app{"tec_dummy"};
  ChimeraTK::TestFacility testFacility;
  
  testFacility.runApplication();

  boost::shared_ptr<TecDummy> TECDummy = boost::dynamic_pointer_cast<TecDummy>(
     ChimeraTK::BackendFactory::getInstance().createBackend(TECDummyCDD));
  
  testFacility.writeScalar("TecModule/readGroup1_wr",1);
  testFacility.stepApplication();
  auto serialNumber = testFacility.readScalar<int>("TecModule/mon_serialNumber_rd");
  BOOST_CHECK_EQUAL(serialNumber,0);
    
  TECDummy->set( TecFrame::TecParameter::MonSerialNumber, 999 ); 
  testFacility.writeScalar("TecModule/readGroup1_wr",2);
  testFacility.stepApplication();
  serialNumber = testFacility.readScalar<int>("TecModule/mon_serialNumber_rd");
  BOOST_CHECK_EQUAL(serialNumber,999);  
  
  
  TECDummy->set( TecFrame::TecParameter::MonSerialNumber, 111 ); 
  testFacility.writeScalar("TecModule/readGroup1_wr",2);
  testFacility.stepApplication();
  serialNumber = testFacility.readScalar<int>("TecModule/mon_serialNumber_rd");
  BOOST_CHECK_EQUAL(serialNumber,111);
  
  
}

BOOST_AUTO_TEST_SUITE_END()
